# CglTreeProbingInfo Class Reference

`#include <CglTreeInfo.hpp>`

Inheritance diagram for CglTreeProbingInfo:
[legend]
Collaboration diagram for CglTreeProbingInfo:
[legend]

List of all members.

## Public Member Functions
| CglTreeProbingInfo ()
| Default constructor.
| CglTreeProbingInfo (const OsiSolverInterface *model)
| Constructor from model.
| CglTreeProbingInfo (const CglTreeProbingInfo &)
| Copy constructor.
virtual CglTreeInfo * | clone () const
| Clone.
CglTreeProbingInfo & | operator= (const CglTreeProbingInfo &rhs)
| Assignment operator.
virtual | ~CglTreeProbingInfo ()
| Destructor.
OsiSolverInterface * | analyze (const OsiSolverInterface &si, int createSolver=0, int numberExtraCliques=0, const int *starts=NULL, const CliqueEntry *entries=NULL, const char *type=NULL)
virtual bool | fixes (int variable, int toValue, int fixedVariable, bool fixedToLower)
| Take action if cut generator can fix a variable (toValue -1 for down, +1 for up) Returns true if still room, false if not.
virtual int | initializeFixing (const OsiSolverInterface *model)
| Initalizes fixing arrays etc - returns >0 if we want to save info 0 if we don't and -1 if is to be used.
int | fixColumns (OsiSolverInterface &si) const
| Fix entries in a solver using implications.
int | fixColumns (int iColumn, int value, OsiSolverInterface &si) const
| Fix entries in a solver using implications for one variable.
int | packDown ()
| Packs down entries.
void | generateCuts (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info) const
| Generate cuts from implications.
CliqueEntry * | fixEntries ()
| Entries for fixing variables.
int * | toZero ()
| Starts of integer variable going to zero.
int * | toOne ()
| Starts of integer variable going to one.
int * | integerVariable () const
| List of 0-1 integer variables.
int * | backward () const
| Backward look up.
int | numberVariables () const
| Number of variables.
int | numberIntegers () const
| Number of 0-1 variables.
## Protected Attributes
CliqueEntry * | fixEntry_
| Entries for fixing variables.
int * | toZero_
| Starts of integer variable going to zero.
int * | toOne_
| Starts of integer variable going to one.
int * | integerVariable_
| List of 0-1 integer variables.
int * | backward_
| Backward look up.
int * | fixingEntry_
| Entries for fixing variable when collecting.
int | numberVariables_
| Number of variables.
int | numberIntegers_
| Number of 0-1 variables.
int | maximumEntries_
| Maximum number in fixEntry_.
int | numberEntries_
| Number entries in fixingEntry_ (and fixEntry_) or -2 if correct style.
## Private Member Functions
void | convert ()
| Converts to ordered.

## Detailed Description

Definition at line 85 of file CglTreeInfo.hpp.

## Constructor & Destructor Documentation

CglTreeProbingInfo::CglTreeProbingInfo | ( |  | ) |

Default constructor.

CglTreeProbingInfo::CglTreeProbingInfo | ( | const OsiSolverInterface * | model | ) |

Constructor from model.

CglTreeProbingInfo::CglTreeProbingInfo | ( | const CglTreeProbingInfo & |  | ) |

Copy constructor.

virtual CglTreeProbingInfo::~CglTreeProbingInfo | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual CglTreeInfo* CglTreeProbingInfo::clone | ( |  | ) | const`[virtual]`

Clone.

Reimplemented from CglTreeInfo.

CglTreeProbingInfo& CglTreeProbingInfo::operator= | ( | const CglTreeProbingInfo & | rhs | ) |

Assignment operator.

Reimplemented from CglTreeInfo.

OsiSolverInterface* CglTreeProbingInfo::analyze | ( | const OsiSolverInterface & | si,
|  | int | createSolver = `0`,
|  | int | numberExtraCliques = `0`,
|  | const int * | starts = `NULL`,
|  | const CliqueEntry * | entries = `NULL`,
|  | const char * | type = `NULL` |
| ) |  |  |

virtual bool CglTreeProbingInfo::fixes | ( | int | variable,
|  | int | toValue,
|  | int | fixedVariable,
|  | bool | fixedToLower |
| ) |  |  | `[virtual]`

Take action if cut generator can fix a variable (toValue -1 for down, +1 for up) Returns true if still room, false if not.

Reimplemented from CglTreeInfo.

virtual int CglTreeProbingInfo::initializeFixing | ( | const OsiSolverInterface * | model | ) | `[virtual]`

Initalizes fixing arrays etc - returns >0 if we want to save info 0 if we don't and -1 if is to be used.

Reimplemented from CglTreeInfo.

int CglTreeProbingInfo::fixColumns | ( | OsiSolverInterface & | si | ) | const

Fix entries in a solver using implications.

int CglTreeProbingInfo::fixColumns | ( | int | iColumn,
|  | int | value,
|  | OsiSolverInterface & | si |
| ) |  |  | const

Fix entries in a solver using implications for one variable.

int CglTreeProbingInfo::packDown | ( |  | ) |

Packs down entries.

void CglTreeProbingInfo::generateCuts | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info |
| ) |  |  | const

Generate cuts from implications.

CliqueEntry* CglTreeProbingInfo::fixEntries | ( |  | ) | `[inline]`

Entries for fixing variables.

Definition at line 126 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toZero | ( |  | ) | `[inline]`

Starts of integer variable going to zero.

Definition at line 129 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toOne | ( |  | ) | `[inline]`

Starts of integer variable going to one.

Definition at line 132 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::integerVariable | ( |  | ) | const`[inline]`

List of 0-1 integer variables.

Definition at line 135 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::backward | ( |  | ) | const`[inline]`

Backward look up.

Definition at line 138 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberVariables | ( |  | ) | const`[inline]`

Number of variables.

Definition at line 141 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberIntegers | ( |  | ) | const`[inline]`

Number of 0-1 variables.

Definition at line 144 of file CglTreeInfo.hpp.

void CglTreeProbingInfo::convert | ( |  | ) | `[private]`

Converts to ordered.

## Member Data Documentation

CliqueEntry* CglTreeProbingInfo::fixEntry_`[protected]`

Entries for fixing variables.

Definition at line 151 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toZero_`[protected]`

Starts of integer variable going to zero.

Definition at line 153 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toOne_`[protected]`

Starts of integer variable going to one.

Definition at line 155 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::integerVariable_`[protected]`

List of 0-1 integer variables.

Definition at line 157 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::backward_`[protected]`

Backward look up.

Definition at line 159 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::fixingEntry_`[protected]`

Entries for fixing variable when collecting.

Definition at line 161 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberVariables_`[protected]`

Number of variables.

Definition at line 163 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberIntegers_`[protected]`

Number of 0-1 variables.

Definition at line 165 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::maximumEntries_`[protected]`

Maximum number in fixEntry_.

Definition at line 167 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberEntries_`[protected]`

Number entries in fixingEntry_ (and fixEntry_) or -2 if correct style.

Definition at line 169 of file CglTreeInfo.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Alps-1.5.0/Cgl/src/CglTreeInfo.hpp